program mm
!
!       (c) 2002/2012 by CASPUR/G.Amati,F.Salvadore
!
    use precision_module
    use timing_module
       
    implicit none
#include "fpapi_test.h"

    integer i,j,k ! index
    integer, parameter :: n=5000            ! size of the matrix

    real(my_kind) a(1:n,1:n) ! matrix
    real(my_kind) b(1:n,1:n) ! matrix
    real(my_kind) c(1:n,1:n) ! matrix (destination)
    real(my_kind) d(1:n,1:n) ! matrix (destination)
    real(my_kind) time1, time2 ! timing
    real(my_kind) :: mflops, aa
    REAL(my_kind) :: DDOT
    REAL*4 proc_time, mflops1, real_time
    INTEGER*8 flpins,retval
    integer*8 flpops  
    integer check,event_code
    integer events(3),num_events
    integer*8    :: values(100),event_set
    character*20      nome

         do i=1,100
            values=0
          end do

          events(1)= PAPI_TOT_INS
          !events(1)= PAPI_FP_INS
          !events(1)= PAPI_FP_OPS

          check = PAPI_VER_CURRENT
          call PAPIF_library_init(check)
          if (check .ne. PAPI_VER_CURRENT) then
             print *, 'Error initializing the PAPI Library'
             call abort
          end if


!
    mflops = 2*float(n)*float(n)*float(n)/(1000.0_my_kind*1000.0_my_kind)
!
    call timing(time1)
    call random_number(a)
    call random_number(b)
    c = 0._my_kind 
    d = 0._my_kind 
    call timing(time2)
    write(*,*) "--------------------------------------"
    write(*,*) " Matrix-Matrix Multiplication using BLAS        "
    write(*,*) " Calcolo con precisione: ",precision(a(1,1))
    write(*,*) " rel. 0, naive multiplication         "
    write(*,*) " size =", n                      
    write(*,*) "--------------------------------------"
!
! main loop
!
        num_events = 1
      call PAPIf_start_counters( events, num_events, retval)

      call PAPIf_read_counters(values, num_events,retval)


#ifdef DD
    call timing(time1)
        do i=1,N
           do j=1,N
           aa=ddot(N,a(i,:),1,b(:,j),1)
           end do
          end do
    call timing(time2)
    print*, "time for DDOT", time2-time1
#endif

#ifdef MV
    call timing(time1)
           do j=1,N
            call DGEMV('n',N,N,1.d0,a,N,b(:,j),1,0.d0,d,1)
           end do
    call timing(time2)
    print*, "time for DGEMV", time2-time1
#endif

#ifdef MM
    call timing(time1)
!
!  qui sotto va completato il programma, prodotto righe per colonne
!   c_ij = c_ij + a_ik * b_kj     
!
    call DGEMM('n','n',N,N,N,1.d0,a,N,b,N,0.d0,c,N)
    call timing(time2)
#endif
      call PAPIf_stop_counters(values,num_events,retval)
!
!  qui sopra va completato il programma, prodotto righe per colonne
!
    print*, "--------------------------------------"
    print*, "time for moltiplication", time2-time1
    print*, "Obtained Mflops                 ", values(1)/((time2-time1)*10**6)
    print*, "Estimated Mflops                 ", mflops/(time2-time1)
    print*, "--------------------------------------"
    print*, "       "
    print*, "       "
!
end program mm

